## Alpha API Report File for "@fluidframework/container-loader"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

// @public
export enum ConnectionState {
    CatchingUp = 1,
    Connected = 2,
    Disconnected = 0,
    EstablishingConnection = 3
}

// @alpha @legacy
export function createDetachedContainer(createDetachedContainerProps: ICreateDetachedContainerProps): Promise<IContainer>;

// @alpha @legacy (undocumented)
export interface IBaseProtocolHandler {
    // (undocumented)
    readonly attributes: IDocumentAttributes;
    // (undocumented)
    close(): void;
    // (undocumented)
    getProtocolState(): IScribeProtocolState;
    // (undocumented)
    processMessage(message: ISequencedDocumentMessage, local: boolean): IProcessMessageResult;
    // (undocumented)
    readonly quorum: IQuorum;
    // (undocumented)
    setConnectionState(connected: boolean, clientId: string | undefined): any;
    // (undocumented)
    snapshot(): IQuorumSnapshot;
}

// @alpha @deprecated @legacy (undocumented)
export interface ICodeDetailsLoader extends Partial<IProvideFluidCodeDetailsComparer> {
    load(source: IFluidCodeDetails): Promise<IFluidModuleWithDetails>;
}

// @alpha @legacy
export interface ICreateAndLoadContainerProps {
    readonly allowReconnect?: boolean | undefined;
    readonly clientDetailsOverride?: IClientDetails | undefined;
    readonly codeLoader: ICodeDetailsLoader_2;
    readonly configProvider?: IConfigProviderBase | undefined;
    readonly documentServiceFactory: IDocumentServiceFactory;
    readonly logger?: ITelemetryBaseLogger | undefined;
    readonly options?: IContainerPolicies | undefined;
    readonly protocolHandlerBuilder?: ProtocolHandlerBuilder | undefined;
    readonly scope?: FluidObject | undefined;
    readonly urlResolver: IUrlResolver;
}

// @alpha @legacy
export interface ICreateDetachedContainerProps extends ICreateAndLoadContainerProps {
    readonly codeDetails: IFluidCodeDetails;
}

// @alpha @deprecated @legacy (undocumented)
export interface IFluidModuleWithDetails {
    details: IFluidCodeDetails;
    module: IFluidModule;
}

// @alpha @legacy
export interface ILoaderProps {
    readonly codeLoader: ICodeDetailsLoader;
    readonly configProvider?: IConfigProviderBase;
    readonly documentServiceFactory: IDocumentServiceFactory;
    readonly logger?: ITelemetryBaseLogger;
    readonly options?: ILoaderOptions;
    readonly protocolHandlerBuilder?: ProtocolHandlerBuilder;
    readonly scope?: FluidObject;
    readonly urlResolver: IUrlResolver;
}

// @alpha @legacy
export interface ILoaderServices {
    readonly codeLoader: ICodeDetailsLoader;
    readonly documentServiceFactory: IDocumentServiceFactory;
    readonly options: ILoaderOptions;
    readonly protocolHandlerBuilder?: ProtocolHandlerBuilder;
    readonly scope: FluidObject;
    readonly subLogger: ITelemetryLoggerExt;
    readonly urlResolver: IUrlResolver;
}

// @alpha @legacy
export interface ILoadExistingContainerProps extends ICreateAndLoadContainerProps {
    readonly pendingLocalState?: string | undefined;
    readonly request: IRequest;
}

// @alpha @legacy
export interface IParsedUrl {
    id: string;
    path: string;
    query: string;
    version: string | undefined;
}

// @alpha @legacy (undocumented)
export interface IProtocolHandler extends IBaseProtocolHandler {
    // (undocumented)
    readonly audience: IAudienceOwner;
    // (undocumented)
    processSignal(message: ISignalMessage): any;
}

// @alpha @legacy
export interface IQuorumSnapshot {
    // (undocumented)
    members: QuorumClientsSnapshot;
    // (undocumented)
    proposals: QuorumProposalsSnapshot["proposals"];
    // (undocumented)
    values: QuorumProposalsSnapshot["values"];
}

// @alpha @legacy
export interface IRehydrateDetachedContainerProps extends ICreateAndLoadContainerProps {
    readonly serializedState: string;
}

// @alpha @legacy (undocumented)
export interface IScribeProtocolState {
    // (undocumented)
    members: [string, ISequencedClient][];
    // (undocumented)
    minimumSequenceNumber: number;
    // (undocumented)
    proposals: [number, ISequencedProposal, string[]][];
    // (undocumented)
    sequenceNumber: number;
    // (undocumented)
    values: [string, ICommittedProposal][];
}

// @alpha @legacy
export class Loader implements IHostLoader {
    constructor(loaderProps: ILoaderProps);
    // (undocumented)
    createDetachedContainer(codeDetails: IFluidCodeDetails, createDetachedProps?: {
        canReconnect?: boolean;
        clientDetailsOverride?: IClientDetails;
    }): Promise<IContainer>;
    // (undocumented)
    rehydrateDetachedContainerFromSnapshot(snapshot: string, createDetachedProps?: {
        canReconnect?: boolean;
        clientDetailsOverride?: IClientDetails;
    }): Promise<IContainer>;
    // (undocumented)
    resolve(request: IRequest, pendingLocalState?: string): Promise<IContainer>;
    // (undocumented)
    readonly services: ILoaderServices;
}

// @alpha @legacy
export function loadExistingContainer(loadExistingContainerProps: ILoadExistingContainerProps): Promise<IContainer>;

// @alpha @legacy
export type ProtocolHandlerBuilder = (attributes: IDocumentAttributes, snapshot: IQuorumSnapshot, sendProposal: (key: string, value: any) => number) => IProtocolHandler;

// @alpha @legacy
export type QuorumClientsSnapshot = [string, ISequencedClient][];

// @alpha @legacy
export type QuorumProposalsSnapshot = {
    proposals: [number, ISequencedProposal, string[]][];
    values: [string, ICommittedProposal][];
};

// @alpha @legacy
export function rehydrateDetachedContainer(rehydrateDetachedContainerProps: IRehydrateDetachedContainerProps): Promise<IContainer>;

// @alpha @legacy
export function resolveWithLocationRedirectionHandling<T>(api: (request: IRequest) => Promise<T>, request: IRequest, urlResolver: IUrlResolver, logger?: ITelemetryBaseLogger): Promise<T>;

// @alpha @legacy
export function tryParseCompatibleResolvedUrl(url: string): IParsedUrl | undefined;

// @alpha @legacy
export function waitContainerToCatchUp(container: IContainer): Promise<boolean>;

// (No @packageDocumentation comment for this package)

```
