"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPackageName = exports.ReconnectMode = void 0;
const internal_1 = require("@fluidframework/container-definitions/internal");
var ReconnectMode;
(function (ReconnectMode) {
    ReconnectMode["Never"] = "Never";
    ReconnectMode["Disabled"] = "Disabled";
    ReconnectMode["Enabled"] = "Enabled";
})(ReconnectMode || (exports.ReconnectMode = ReconnectMode = {}));
/**
 * Gets the name of the Fluid package.
 * @param codeDetails- - Data structure used to describe the code to load on the Fluid document
 */
const getPackageName = (codeDetails) => {
    // TODO: use a real type
    // This is the normal path that any modern customer would hit
    const containerPackageName = (0, internal_1.isFluidPackage)(codeDetails?.package)
        ? codeDetails?.package.name
        : codeDetails?.package;
    return { name: containerPackageName };
};
exports.getPackageName = getPackageName;
//# sourceMappingURL=contracts.js.map