/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { IThrottlingWarning } from "@fluidframework/core-interfaces/internal";
import { IFluidErrorBase, ITelemetryLoggerExt, LoggingError } from "@fluidframework/telemetry-utils/internal";
/**
 * Warning emitted when requests to storage are being throttled.
 */
export declare class ThrottlingWarning extends LoggingError implements IThrottlingWarning, IFluidErrorBase {
    readonly retryAfterSeconds: number;
    /**
     * {@inheritDoc @fluidframework/telemetry-utils#IFluidErrorBase.errorType}
     */
    readonly errorType: "throttlingError";
    private constructor();
    /**
     * Wrap the given error as a ThrottlingWarning
     * Only preserves the error message, and applies the given retry after to the new warning object
     */
    static wrap(error: unknown, retryAfterSeconds: number, logger: ITelemetryLoggerExt): IThrottlingWarning;
}
//# sourceMappingURL=error.d.ts.map