/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { TypedEventEmitter } from "@fluid-internal/client-utils";
import { IEvent } from "@fluidframework/core-interfaces";
import { ISequencedDocumentMessage } from "@fluidframework/driver-definitions/internal";
export interface INoopSenderEvents extends IEvent {
    (event: "wantsNoop", listener: () => void): any;
}
export declare class NoopHeuristic extends TypedEventEmitter<INoopSenderEvents> {
    private readonly NoopCountFrequency;
    private opsProcessedSinceOpSent;
    private readonly timer;
    constructor(NoopTimeFrequency?: number, NoopCountFrequency?: number);
    /**
     * Schedules as ack to the server to update the reference sequence number
     */
    notifyMessageProcessed(message: ISequencedDocumentMessage): void;
    notifyDisconnect(): void;
    notifyMessageSent(): void;
}
//# sourceMappingURL=noopHeuristic.d.ts.map